/**
  *  \file lregexp1.h
  */
#ifndef LREGEXP1_H_INCLUDED
#define LREGEXP1_H_INCLUDED

#include <string>
#include "rx/regexp.h"
#include "lispy.h"

class LRegResult;

class LRegExp : public LSelfEval {
    regexp* pregexp;
 public:
    LRegExp(std::string re);
    ~LRegExp();

    std::string toString();

    friend class LRegResult;
};

class LRegResult : public LSelfEval {
    enum { MAX_MATCH = 10 };
    std::string value;
    int startp[MAX_MATCH], endp[MAX_MATCH];
    int nmatch;
    bool ok;
 public:
    LRegResult(std::string value, const LRegExp& expr);
    ~LRegResult();

    std::string toString();

    LPtr getMatch(int n) const;

    bool isOK() const
        { return ok; }
};

void initRegexp();

#endif
